/**********************************************************************************
CH395 TCP/IP Эӿ
Socket0MAC RAWģʽ£Ƭյݺֱϴ
**********************************************************************************/

/* ͷļ*/
#include "debug.h"
#include "stdio.h"
#include "string.h"
#include "../PUB/CH395INC.H"
#include "CH395.H"

/**********************************************************************************
/*
CH395_OP_INTERFACE_MODEΪ1-5
1Ӳ߲ӷʽ
2ģⲢӷʽ
3: ӲSPIӷʽ
4: ģSPIʽ
5: Ӳ첽ӷʽ
*/
#define   CH395_OP_INTERFACE_MODE             3
#if   (CH395_OP_INTERFACE_MODE == 1)                                 /* SEL = 0, TX = 1*/
#include "../PUB/CH395PARA_HW.C"
#elif (CH395_OP_INTERFACE_MODE == 2)                                 /* SEL = 0, TX = 1*/
#include "../PUB/CH395PARA_SW.C"
#elif (CH395_OP_INTERFACE_MODE == 3)                                 /* SEL = 1, TX = 0*/
#include "../PUB/CH395SPI_HW.H"
#elif (CH395_OP_INTERFACE_MODE == 4)                                 /* SEL = 1, TX = 0*/
#include "../PUB/CH395SPI_SW.C"
#elif (CH395_OP_INTERFACE_MODE == 5)                                 /* SEL = 1, TX = 1*/
#include "../PUB/CH395UART.H"
#else
#error "Please Select Correct Communication Interface "
#endif

/**********************************************************************************/
/* ļ */
#include "../PUB/CH395CMD.H"

#define CH395_INT_WIRE    GPIO_ReadInputDataBit(GPIOA,GPIO_Pin_0)    /* CH395INT# */

#define  CH395_DEBUG                1

/* ñ */
UINT8  MyBuffer[512];                                               /* ݻ */
struct _SOCK_INF  SockInf;                                           /* SocketϢ */
struct _CH395_SYS CH395Inf;                                          /* CH395Ϣ */

/* CH395ض */
//const UINT8 CH395MACAddr[6] = {0xb8,0xae,0x1d,0x26,0x27,0x28};       /* CH395MACַ */
/*עCH395ʱ¼MACַ˴MACַҪΪʾʹʱֱӵûȡMACַMACַ*/

/**********************************************************************************
* Function Name  : mStopIfError
* Description    : ʹãʾ룬ͣ
* Input          : iError
* Output         : None
* Return         : None
**********************************************************************************/
void mStopIfError(UINT8 iError)
{
    if (iError == CMD_ERR_SUCCESS) return;                           /* ɹ */
#if CH395_DEBUG
    printf("Error: %02X\n", (UINT16)iError);                         /* ʾ */
#endif
    while ( 1 )
    {
        Delay_Ms(200);
        Delay_Ms(200);
    }
}

/**********************************************************************************
* Function Name  : InitCH395InfParam
* Description    : ʼCH395Inf
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void InitCH395InfParam(void)
{
    memset(&CH395Inf,0,sizeof(CH395Inf));                            /* CH395Infȫ*/
//    memcpy(CH395Inf.MacAddr,CH395MACAddr,sizeof(CH395MACAddr));      /* MACַ */
}

/**********************************************************************************
* Function Name  : InitSocketParam
* Description    : ʼsocket
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void InitSocketParam(void)
{
    memset(&SockInf,0,sizeof(SockInf));                              /* SockInf0ȫ*/
    SockInf.ProtoType = PROTO_TYPE_MAC_RAW;                          /* MAC RAWģʽ */
}

/**********************************************************************************
* Function Name  : CH395SocketInitOpen
* Description    : CH395 socket ʼsocket
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void CH395SocketInitOpen(void)
{
    UINT8 i;

    /* socket 0ΪMAC RAWģʽ */
    CH395SetSocketProtType(0,SockInf.ProtoType);                     /* socket 0Э */
    i = CH395OpenSocket(0);                                          /* socket 0 */
    mStopIfError(i);                                                 /* Ƿɹ */
}

/**********************************************************************************
* Function Name  : CH395SocketInterrupt
* Description    : CH395 socket ж,ȫжб
* Input          : sockindex
* Output         : None
* Return         : None
**********************************************************************************/
void CH395SocketInterrupt(UINT8 sockindex)
{
   UINT8  sock_int_socket,tmp1[6],tmp2[6],i;
   UINT16 len;

   sock_int_socket = CH395GetSocketInt(sockindex);                   /* ȡsocket ж״̬ */
   if(sock_int_socket & SINT_STAT_SENBUF_FREE)                       /* ͻУԼдҪ͵ */
   {//ͻ־λ
   }
   if(sock_int_socket & SINT_STAT_SEND_OK)                           /* ж */
   {
   }
   if(sock_int_socket & SINT_STAT_RECV)                              /* ж */
   {
        len = CH395GetRecvLength(sockindex);                          /* ȡǰݳ */
#if CH395_DEBUG
  printf("receive len = %d\n",len);
#endif
        if(len == 0)return;
        if(len > 512) len = 512;                                      /*MyBufferΪ512*/
        CH395GetRecvData(sockindex,len,MyBuffer);                     /* ȡ */

        CH395CMDGetMACAddr(MyBuffer);                                 /*395MACַ84 C2 E4 FA 12 0E */

        for(i=0;i<6;i++)                                              /*յǰ12ֽλĿMacַԴMacַλýת*/
        {
            tmp1[i] =  MyBuffer[i];
        }
        for(i=0;i<6;i++)
        {
            tmp2[i] =  MyBuffer[i+6];
        }
        for(i=0;i<6;i++)
        {
            MyBuffer[i] =  tmp2[i];
        }
        printf("ĿPCMAC %02X:%02X:%02X:%02X:%02X:%02X\n",MyBuffer[0],MyBuffer[1],MyBuffer[2],MyBuffer[3],MyBuffer[4],MyBuffer[5]);
        for(i=0;i<6;i++)
        {
            MyBuffer[i+6] =  tmp1[i];
        }
        printf("Դ395MAC  %02X:%02X:%02X:%02X:%02X:%02X\n",MyBuffer[6],MyBuffer[7],MyBuffer[8],MyBuffer[9],MyBuffer[10],MyBuffer[11]);
        CH395SendData(sockindex,MyBuffer,len);
    }
/*
  **ϿжϺͳʱжʱCH395ĬڲرգûҪԼرոSocketóɲرSocketҪ
  **SOCK_CTRL_FLAG_SOCKET_CLOSE־λĬΪ0ñ־Ϊ1CH395ڲSocketйرմûжϺͳʱжʱ
  **CH395CloseSocketSocketйرգرSocketһֱΪӵ״̬ʵѾϿͲȥˡ
  */
  if(sock_int_socket & SINT_STAT_CONNECT)                           /* жϣTCPģʽЧ*/
  {
  }
  if(sock_int_socket & SINT_STAT_DISCONNECT)                        /* ϿжϣTCPģʽЧ */
  {
       printf("Ͽж \n");
  }
  if(sock_int_socket & SINT_STAT_TIM_OUT)                           /* ʱж */
  {
       printf("ʱж \n");
  }
}

/**********************************************************************************
* Function Name  : CH395GlobalInterrupt
* Description    : CH395ȫжϺ
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void CH395GlobalInterrupt(void)
{
    UINT16  init_status;
    UINT8   buf[64];

    init_status = CH395CMDGetGlobIntStatus_ALL();
    if(init_status & GINT_STAT_UNREACH)                              /* ɴжϣȡɴϢ */
    {
        printf("ɴж\n");
        CH395CMDGetUnreachIPPT(buf);
    }
    if(init_status & GINT_STAT_IP_CONFLI)                            /* IPͻжϣ޸CH395 IPʼCH395*/
    {
    }
    if(init_status & GINT_STAT_PHY_CHANGE)                           /* PHYıж*/
    {
#if CH395_DEBUG
        printf("Init status : GINT_STAT_PHY_CHANGE\n");
#endif
    }
    if(init_status & GINT_STAT_SOCK0)
    {
        CH395SocketInterrupt(0);                                     /* socket 0ж*/
    }
    if(init_status & GINT_STAT_SOCK1)
    {
        CH395SocketInterrupt(1);                                     /* socket 1ж*/
    }
    if(init_status & GINT_STAT_SOCK2)
    {
        CH395SocketInterrupt(2);                                     /* socket 2ж*/
    }
    if(init_status & GINT_STAT_SOCK3)
    {
        CH395SocketInterrupt(3);                                     /* socket 3ж*/
    }
    if(init_status & GINT_STAT_SOCK4)
    {
        CH395SocketInterrupt(4);                                     /* socket 4ж*/
    }
    if(init_status & GINT_STAT_SOCK5)
    {
        CH395SocketInterrupt(5);                                     /* socket 5ж*/
    }
    if(init_status & GINT_STAT_SOCK6)
    {
        CH395SocketInterrupt(6);                                     /* socket 6ж*/
    }
    if(init_status & GINT_STAT_SOCK7)
    {
        CH395SocketInterrupt(7);                                     /* socket 7ж*/
    }
}

/*********************************************************************************
* Function Name  : CH395Init
* Description    : CH395IP,GWIP,MACȲʼ
* Input          : None
* Output         : None
* Return         : ִн
**********************************************************************************/
UINT8  CH395Init(void)
{
    UINT8 i;

    i = CH395CMDCheckExist(0x65);
    if(i != 0x9a)return CH395_ERR_UNKNOW;                            /* ޷ͨ0XFA */
                                                                     /* 0XFAһΪӲ߶дʱ򲻶 */
#if (CH395_OP_INTERFACE_MODE == 3)
#ifdef UART_WORK_BAUDRATE
    CH395CMDSetUartBaudRate(UART_WORK_BAUDRATE);                     /* ò */
    Delay_Ms(1);
#endif
#endif
/*עCH395ʱ¼MACַ˴MACַҪΪʾʹʱֱӵûȡMACַMACַ*/
//    CH395CMDSetMACAddr(CH395Inf.MacAddr);                            /* CH395MACַMAC RAWҪMACַ */
    Delay_Ms(200);                                                   /*Ҫʱ*/
    Delay_Ms(200);
    Delay_Ms(200);
    Delay_Ms(200);
    Delay_Ms(200);
    Delay_Ms(200);
    Delay_Ms(200);
    Delay_Ms(200);
    Delay_Ms(200);
    i = CH395CMDInitCH395();                                         /* ʼCH395оƬ */
    return i;
}

/**********************************************************************************
* Function Name  : main
* Description    : main
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/

int main(void)
{
    UINT8 i;
//    u8 mac[10];

    Delay_Init();
    USART_Printf_Init(115200);
    printf("start!\n");
#if CH395_DEBUG
    printf("CH395EVT Test Demo\n");
#endif
    CH395_PORT_INIT();                                               /* ʼƬ */

    CH395CMDReset();                                                 /* λCH395оƬ */
    Delay_Ms(1000);                                                  /* ʱ1000,ҪֿдЧ */
    Delay_Ms(1000);

    i = CH395CMDGetVer();                                            /*ȡоƬԼ̼汾 */
    printf("CH395CMDGetVer:%02x\n",i);
    InitCH395InfParam();                                             /* ʼCH395ر */
    i = CH395Init();                                                 /* ʼCH395оƬ */
    printf("CH395Init:%02x\n",i);
    mStopIfError(i);                                                 /*ʹãʾ룬ͣ*/
	printf("end!\n");
	//    u8 mac[10];
//	CH395CMDGetMACAddr(mac);//84 C2 E4 FA 12 0E 395MACַ
//	printf("%x\n%x\n%x\n%x\n%x\n%02x\n",mac[0],mac[1],mac[2],mac[3],mac[4],mac[5]);
	while(1)
    {                                                                /* ȴ̫ӳɹ*/
       if(CH395CMDGetPHYStatus() == PHY_DISCONN)                     /* ѯCH395Ƿ */
       {
           Delay_Ms(200);                                            /* δȴ200MSٴβѯ */
       }
       else
       {
#if CH395_DEBUG
           printf("CH395 Connect Ethernet\n");                       /* CH395оƬӵ̫ʱж */
#endif
           break;
       }
    }
	InitSocketParam();                                               /* ʼsocketر */
	CH395SocketInitOpen();
	while(1)
	{
	    if(CH395_INT_WIRE==RESET)                                    /* жŵƽ仯ȫж */
		{
	        CH395GlobalInterrupt();
		}
	}
}

